core/urls.py
from django.contrib import admin
from django.urls import include, path, re_path
from rest_framework import routers

from datacenter.views import DeviceViewSet, RackListView, RackViewSet

router = routers.DefaultRouter()
router.register(r"racks", RackViewSet)
router.register(r"devices", DeviceViewSet)

urlpatterns = [
    path("datacenter/admin/", admin.site.urls),
    path("datacenter/", include("datacenter.urls")),
    path("api/", include(router.urls)),
    path("api/racks", RackViewSet.as_view({"get": "list"}), name="drf-racks"),
    path("api/devices", DeviceViewSet.as_view({"get": "list"}), name="drf-devices"),
    re_path(r"|home", RackListView.as_view(), name="home"),
]

datacenter/urls.py
from django.urls import path, re_path

from . import views

app_name = "datacenter"

urlpatterns = [
    path("home", views.RackListView.as_view(), name="datacenter-home"),
    re_path(
        r"devices-list", views.DevicesList.as_view(), name="datacenter-devices-list"
    ),
    re_path(
        r"rack-create/(?P<pk>[0-9]+)*",
        views.RackCreateView.as_view(),
        name="rack-create",
    ),
    re_path(
        r"rack-update/(?P<pk>[0-9]+)*",
        views.RackUpdateView.as_view(),
        name="rack-update",
    ),
    re_path(
        r"device-create/(?P<pk_device>[0-9]+)*/(?P<pk_rack>[0-9]+)*",
        views.DeviceCreateView.as_view(),
        name="device-create",
    ),
    re_path(
        r"device-update/(?P<pk_device>[0-9]+)*/(?P<pk_rack>[0-9]+)*",
        views.DeviceUpdateView.as_view(),
        name="device-update",
    ),
    re_path(
        r"device-delete-from-rack/(?P<pk>[0-9]+)*/(?P<pk_rack>[0-9]+)*",
        views.DeviceDeleteView.as_view(),
        name="device-delete-from-rack",
    ),
]

datacenter/models/user.py
from django.contrib.auth.models import AbstractUser, Group, Permission
from django.db import models
from simple_history.models import HistoricalRecords


class User(AbstractUser):

    history = HistoricalRecords(inherit=True, cascade_delete_history=True)

    groups = models.ManyToManyField(
        Group,
        verbose_name="localgroups",
        blank=True,
        help_text="Le groupe auquel cet utilisateur appartient",
        related_name="localuser_set",
        related_query_name="localuser",
    )

    user_permissions = models.ManyToManyField(
        Permission,
        verbose_name="localpermissions",
        blank=True,
        help_text="Permissions spécifiques à cet utilisateur.",
        related_name="localuser_set",
        related_query_name="localuser",
    )

    def __str__(self):
        return f"{self.last_name} {self.first_name}"

datacenter/forms.py
from crispy_bootstrap5.bootstrap5 import FloatingField
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout
from django.forms import ModelForm

from datacenter.models.main import Device, Rack


class RackForm(ModelForm):
    """Rack form for creation and update using crispy forms."""

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper()  # crispy

        self.helper.form_tag = False  # False -> render fields without form balise to include several forms in the same page
        self.helper.form_show_errors = True

        # add prefix to distinguish rack's in_state field from device's one in POST
        self.prefix = "rack"

        self.helper.layout = Layout(
            FloatingField("physical_location", css_class="my-2"),
            FloatingField("available_vertical_units", css_class="my-2"),
            FloatingField("in_state", css_class="my-2"),
        )

    class Meta:
        model = Rack
        fields = "__all__"


class DeviceCreateForm(ModelForm):
    """Device form for creation with field rack not displayed and not required."""

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        # add prefix to distinguish device's in_state field from rack's one in POST
        self.prefix = "device"

        self.helper = FormHelper()  # crispy

        self.helper.form_tag = False  # False -> render fields without form balise to include several forms in the same page
        self.helper.form_show_errors = True

        # do not display field for rack
        self.helper.layout = Layout(
            FloatingField("device_type", css_class="my-2"),
            FloatingField("model_name", css_class="my-2"),
            FloatingField("number_of_ports", css_class="my-2"),
            FloatingField("vertical_size", css_class="my-2"),
            FloatingField("in_state", css_class="my-2"),
        )
        # rack will be added on save in post method
        # it should not be required for form_valid
        self.fields["rack"].required = False

    class Meta:
        model = Device
        fields = "__all__"


class DeviceUpdateForm(DeviceCreateForm):
    """Device form for update with field rack visible and required."""

    def __init__(self, *args, **kwargs):
        # heritate from DeviceCreateForm
        super().__init__(*args, **kwargs)

        # set required attribute for field rack
        self.fields["rack"].required = True

        # redefine layout with additional field for rack
        self.helper.layout = Layout(
            FloatingField("device_type", css_class="my-2"),
            FloatingField("model_name", css_class="my-2"),
            FloatingField("number_of_ports", css_class="my-2"),
            FloatingField("vertical_size", css_class="my-2"),
            FloatingField("in_state", css_class="my-2"),
            FloatingField("rack", css_class="my-2"),
        )

datacenter/views.py
import logging

from core.settings.main import (
    ALLOW_API_READ_WITHOUT_AUTHENTICATION,
    PAGINATE_BY_CBV_DEVICES,
    PAGINATE_BY_CBV_RACKS,
)
from django.contrib import messages
from django.shortcuts import redirect, reverse
from django.views.generic.edit import CreateView, DeleteView, FormView, UpdateView
from django.views.generic.list import ListView
from rest_framework import permissions, viewsets

from .forms import DeviceCreateForm, DeviceUpdateForm, RackForm
from .mixins import MixinDevicePost, MixinPageTitle, MixinRackPost, MixinSuccessMsg
from .models.main import Device, Rack
from .serializers import DeviceSerializer, RackSerializer

logger = logging.getLogger(__name__)


class RackListView(MixinPageTitle, ListView):
    """View to render home page with paginated list of racks
        order by descendant ID.

    Args:
        paginate_by:
            Defined in conf_initial dict in core.config file by the key PAGINATE_BY_CBV_RACKS.
        page_title:
            type: str
            Model's verbose name, pluralize if needed, auto set by MixinPageTitle (self.get_queryset_page_title()).

    Returns:
        List of active racks with annotation for number of devices
        and total of used vertical units per rack.
    """

    model = Rack
    template_name = "datacenter/racks-list.html"
    context_object_name = "racks"
    paginate_by = PAGINATE_BY_CBV_RACKS
    action_name = "list"

    def get_context_data(self, **kwargs):
        """Set context page title and queryset for HTML page."""
        context = super().get_context_data(**kwargs)
        self.queryset = Rack.objects.get_annotate_racks()
        context["racks"] = self.queryset
        return context


class DevicesList(MixinPageTitle, ListView):
    """View to render paginated list of devices
       order by their rack's physical location and ID.

    Args:
        paginate_by:
            Defined in conf_initial dict in core.config file by the key PAGINATE_BY_CBV_DEVICES.
        page_title:
            type: str
            Model's verbose name, pluralize if needed, auto set by MixinPageTitle (self.get_queryset_page_title()).

    Returns:
        List of active devices with theirs associated racks.
    """

    model = Device
    template_name = "datacenter/devices-list.html"
    context_object_name = "devices"
    paginate_by = PAGINATE_BY_CBV_DEVICES
    action_name = "list"

    def get_context_data(self, **kwargs):
        """Set context page title and queryset for HTML page."""
        context = super().get_context_data(**kwargs)
        self.queryset = Device.objects.get_active_devices()
        context["devices"] = self.queryset
        return context


class RackCreateView(
    MixinPageTitle,
    MixinSuccessMsg,
    CreateView,
):
    """View to create new Rack.

    Args:
        msg:
            type: str
            For display or log errors
        action_name:
            type: str
            Name to display in HMTL messages and title
        form_action:
            type: str
            URL name for use in HTML form's action attribute in HTML detail page

    Returns:
        A new Rack's instance along with its associated first device
        and redirects to datacenter-rack-detail
    """

    model = Rack
    template_name = "datacenter/rack-detail.html"
    form_class = RackForm
    action_name = "create"
    msg = ""

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["form_action"] = "datacenter:rack-create"
        return context


class RackUpdateView(
    MixinPageTitle,
    MixinRackPost,
    UpdateView,
):
    """View to update a Rack.

    Args:
        msg:
            type: str
            For display or log errors
        action_name:
            type: str
            Name to display in HMTL messages and title
        form:
            type: ModelForm
            A RackForm to create the new Rack.
        form_device:
            type: ModelForm
            A DeviceCreateForm to create another Device at a time.
        form_action:
            type: str
            URL name for use in HTML form's action attribute in HTML detail page

    Returns:
        The Rack's instance along with its associated device(s)
        and redirects to datacenter-rack-detail
    """

    model = Rack
    template_name = "datacenter/rack-detail.html"
    form_class = RackForm
    action_name = "update"
    msg = ""

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["form_action"] = "datacenter:rack-update"
        return context

    def dispatch(self, request, *args, **kwargs):
        self.pk = self.kwargs.get("pk", None)
        self.object = Rack.objects.get(pk=self.pk)

        return super().dispatch(request, *args, **kwargs)


class DeviceCreateView(MixinPageTitle, MixinDevicePost, FormView):
    """View to create new Device.

    Args:
        form:
            type: ModelForm
            A DeviceCreateForm to create a Device
        form_action:
            type: str
            URL name for use in HTML form's action attribute in HTML detail page

    Returns:
        A new Device's instance and redirects to datacenter-rack-detail
    """

    model = Device
    template_name = "datacenter/device-detail.html"
    form_class = DeviceCreateForm
    action_name = "create"
    msg = ""

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["form_action"] = "datacenter:device-create"
        return context


class DeviceUpdateView(MixinPageTitle, MixinDevicePost, FormView):
    """View to update a Device or change its related Rack.

    Args:
        msg:
            type: str
            For display or log errors
        action_name:
            type: str
            Name to display in HMTL messages and title
        form_device:
            type: ModelForm
            A DeviceUpdateForm to update a Device
        form_action:
            type: str
            URL name for use in HTML form's action attribute in HTML detail page

    Returns:
        An updated Device's instance and redirects to datacenter-rack-detail
    """

    model = Device
    form_class = DeviceUpdateForm
    template_name = "datacenter/device-detail.html"
    action_name = "update"
    msg = ""

    def get_context_data(self, **kwargs):
        """Set context for HTML page."""
        context = super().get_context_data(**kwargs)
        context["pk_device"] = self.pk
        context["pk_rack"] = self.object.rack.pk
        # redeclaration of form_device in context in order
        # to have an update form instead of a create form for the device
        context["form_device"] = DeviceUpdateForm(instance=self.object)
        context["form_action"] = "datacenter:device-update"
        return context

    def dispatch(self, request, *args, **kwargs):
        self.pk = self.kwargs.get("pk_device", None)
        self.object = Device.objects.get(pk=self.pk)
        return super().dispatch(request, *args, **kwargs)


class DeviceDeleteView(DeleteView):
    """View to delete a Device from its Rack.

    Args:
        pk_rack:
            type: int
            The pk of the Rack's instance from which the device will be deleted.

    Returns:
        Redirects to datacenter:rack-update.
    """

    model = Device
    template_name = "datacenter/device_confirm_delete.html"

    def get_context_data(self, **kwargs):
        """Set context pk_rack variable for HTML page."""
        context = super().get_context_data(**kwargs)
        self.pk_rack = kwargs.get("rack")
        context["pk_rack"] = self.pk_rack
        return context

    def dispatch(self, request, *args, **kwargs):
        self.pk = self.kwargs.get("pk", None)
        self.object = Device.objects.get(pk=self.pk)
        self.pk_rack = self.kwargs.get("pk_rack", None)
        return super().dispatch(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        """Override post method to redirect to rack."""
        # generate success message with variables
        self.success_message = self.get_success_message()
        # add message to context
        messages.add_message(
            self.request, messages.SUCCESS, self.success_message, "success"
        )
        # delete device
        self.object.delete()
        # redirect to rack's update view with pk_rack in kwargs
        return redirect(
            reverse("datacenter:rack-update", kwargs={"pk_rack": self.pk_rack})
        )

    def get_success_message(self, cleaned_data=None):
        """Override method to generate success_message after form validation."""
        self.success_message = (
            "%(model_name)s %(object)s has been deleted from Rack %(pk_rack)s."
        )
        model_name = self.model._meta.verbose_name  # get model's verbose name

        return self.success_message % dict(
            object=self.object,
            model_name=model_name,
            pk_rack=self.object.rack.pk,
        )


class RackViewSet(viewsets.ReadOnlyModelViewSet):
    """API endpoint that allows racks to be viewed in read-only mode."""

    queryset = Rack.objects.all().order_by("physical_location", "-id")
    serializer_class = RackSerializer

    if not ALLOW_API_READ_WITHOUT_AUTHENTICATION:
        permission_classes = [permissions.IsAuthenticated]


class DeviceViewSet(viewsets.ReadOnlyModelViewSet):
    """API endpoint that allows devices to be viewed in read-only mode."""

    queryset = Device.objects.all().order_by("-rack__id", "model_name")
    serializer_class = DeviceSerializer

    if not ALLOW_API_READ_WITHOUT_AUTHENTICATION:
        permission_classes = [permissions.IsAuthenticated]

templates/datacenter/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Datacenter gestion application">
    <meta name="keywords" content="switch, router">
    <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}" />
    <link rel="stylesheet" href="{% static 'css/custom.css' %}" />
    <script src="{% static 'js/bootstrap.bundle.min.js' %}"></script>
    <script src="{% static 'js/htmx.min.js' %}"></script>
    <script src="{% static 'js/select_autocomplete.js' %}"></script>
    <title>Datacenter</title>
  </head>
  <body>
    {% include 'datacenter/navbar.html' %}
    <div class="row col-10 border-left border-right p-0 m-auto bg-light">
      {% if messages %}
        <div id="dj_alert_msg" class="row">
          <div class="col-xxl-6 col-xl-6 col-lg-6 col-sm-12 mx-auto p-0">
            {% for message in messages %}
              <div {% if message.tags %}class="col-xl-12 alert alert-{{ message.tags }} p-4"{% endif %}
                   role="alert">{{ message|safe }}</div>
            {% endfor %}
          </div>
        </div>
      {% endif %}
      {% block content %}{% endblock %}
    </div>
    {% include 'datacenter/footer.html' %}
  </body>
</html>

templates/datacenter/device-detail.html
{% extends 'datacenter/base.html' %}
<!-- load crispy tags -->
{% load crispy_forms_tags %}
{% block content %}
  <div class="row col-xxl-6 col-xl-6 col-lg-8 col-md-10 m-auto p-0 mb-5">
    <div class="row bg-black border-bottom mt-3 mx-auto">
      <h1 class="text-white text-center">
        <a class="text-decoration-none text-white"
           href="{% if pk_rack %}{% url 'datacenter:rack-update' pk=pk_rack %}{% else %}{% endif %}">
          {% if pk_rack %}
            Rack {{ pk_rack }} /
          {% else %}
          {% endif %}
        {{ page_title }}</a>
      </h1>
    </div>
    <form action="{% url form_action pk_device=pk_device %}" method="post">
      {% csrf_token %}
      <!-- add form errors displayed via crispy -->
      {{ form|as_crispy_errors:"bootstrap5" }}
      <!-- add crispy form helper and layout -->
      {% crispy form_device %}
      <hr>
      <div class="row col-12 bg-dark text-white mx-auto px-1 pt-2 pb-3 mt-2">
        {% if pk_rack %}
          <div class="col-xxl-4 col-xl-4 col-lg-4 col-md-6 col-sm-12 p-0 px-1 mt-2 mx-auto">
            <a class="col-12 btn btn-danger text-white"
               href="{% url 'datacenter:device-delete-from-rack' pk_device pk_rack %}">Delete device</a>
          </div>
        {% else %}
        {% endif %}
        <div class="col-xxl-4 col-xl-4 col-lg-4 col-md-6 col-sm-12 mx-auto p-0 px-1 mt-2">
          <input class="col-12 btn btn-dark text-white border border-white"
                 type="submit"
                 name="submit_device"
                 value="Save device" />
        </div>
      </div>
    </form>
  </div>
{% endblock %}

templates/datacenter/device-new-detail-modal.html
<!-- load crispy tags -->
{% load crispy_forms_tags %}
<button type="button"
        class="col-12 btn btn-dark text-white border border-white"
        data-bs-toggle="modal"
        data-bs-target="#newDeviceModal"
        data-bs-whatever="@nDv">{{ page_title }}</button>
<div class="modal fade"
     id="newDeviceModal"
     tabindex="-1"
     aria-labelledby="newDeviceModalLabel"
     aria-hidden="true">
  <div class="modal-dialog px-3">
    <div class="modal-content">
      <div class="modal-header bg-secondary text-white border">
        <h1 class="modal-title fs-5" id="newDeviceModalLabel">{{ page_title }}</h1>
        <button type="button"
                class="btn-close"
                data-bs-dismiss="modal"
                aria-label="Close"></button>
      </div>
      <div class="modal-body px-3 text-dark">
        <div class="row col-12 m-auto p-0">
          <div class="col-12 border-bottom pb-2 my-2">
            <form action="{% url 'datacenter:device-create' pk_rack=pk_rack %}"
                  method="post">
              <!-- add form errors displayed via crispy -->
              {{ form|as_crispy_errors:"bootstrap5" }}
              {% crispy form_device %}
            </div>
          </div>
        </div>
        <div class="modal-footer px-3">
          <div class="row col-12 p-2">
            <button type="button"
                    class="col-6 border border-white btn btn-secondary"
                    data-bs-dismiss="modal">Close</button>
            <button class="col-6 border border-white btn btn-dark text-white"
                    type="submit"
                    name="submit_device">Save</button>
          </form>
        </div>
      </div>
    </div>
  </div>
</div>

templates/datacenter/device_confirm_delete.html
{% extends "datacenter/base.html" %}
{% block content %}
  <div class="modal-dialog px-3 mt-5">
    <div class="modal-content">
      <div class="modal-header bg-secondary text-white border">
        <h1 class="modal-title fs-5 p-2">Delete Device</h1>
      </div>
      <div class="modal-body px-3">
        <div class="row col-12 m-auto p-0">
          <div class="col-12 border-bottom pb-2 my-2">
            <form method="post">
              {% csrf_token %}
              <p>Are you sure you want to delete « {{ object }} »?</p>
            </div>
          </div>
        </div>
        <div class="modal-footer px-3">
          <div class="row col-12 p-2">
            <button type="button" class="col-6 border border-white btn btn-secondary">
              <a class="text-decoration-none text-white"
                 href="{% url 'datacenter:device-update' pk_device=object.id %}">Close</a>
            </button>
            <button class="col-6 border border-white btn btn-dark text-white"
                    type="submit"
                    name="submit">Confirm</button>
          </form>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

templates/datacenter/devices-list.html
{% extends 'datacenter/base.html' %}
{% block content %}
  {% if is_paginated %}
    <div class="row col-12 m-auto bg-secondary mx-auto p-0">
      <div class="col-xxl-3 col-xl-3 col-lg-3 col-md-3 col-sm-4 p-2 text-end mx-auto">
        <div class="col-12 bg-black text-white p-2 mx-auto">Page {{ page_obj.number }}/{{ paginator.num_pages }}</div>
      </div>
      {% if page_obj.has_other_pages %}
        <div class="col-xxl-9 col-xl-9 col-lg-9 col-md-9 col-sm-8 p-2 mx-auto">
          <div class="row col-12 p-0 text-end mx-auto">
            {% if page_obj.has_previous %}
              <div class="col mx-auto">
                <div class="col-12 bg-black p-2 mx-auto">
                  <a class="bg-black p-2 text-white text-decoration-none"
                     href="{{ request.path }}?page=1">First page</a>
                </div>
              </div>
              <div class="col mx-auto">
                <div class="col-12 bg-black p-2 mx-auto">
                  <a class="bg-black p-2 text-white text-decoration-none"
                     href="{{ request.path }}?page={{ page_obj.previous_page_number }}">Previous page</a>
                </div>
              </div>
            {% else %}
            {% endif %}
            {% if page_obj.has_next %}
              <div class="col mx-auto">
                <div class="col-12 bg-black p-2 mx-auto">
                  <a class="p-2 bg-black text-white text-decoration-none"
                     href="{{ request.path }}?page={{ page_obj.next_page_number }}">Next page</a>
                </div>
              </div>
              <div class="col mx-auto">
                <div class="col-12 bg-black p-2 mx-auto">
                  <a class="p-2 bg-black text-white text-decoration-none"
                     href="{{ request.path }}?page={{ page_obj.paginator.num_pages }}">Last page</a>
                </div>
              </div>
            {% else %}
            {% endif %}
          </div>
        {% else %}
        {% endif %}
      </div>
    </div>
  {% else %}
  {% endif %}
  <div class="row bg-black border-bottom mt-3 mx-auto p-0 ">
    <h1 class="text-white text-center">{{ devices.count }}/{{ paginator.count }} {{ page_title }}</h1>
  </div>
  <div class="row align-items-center bg-black text-white border-bottom mx-auto py-2">
    <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center my-auto">ID</div>
    <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center my-auto">Detail</div>
    <div class="col-xxl-3 col-xl-3 col-lg-3 col-md-3 col-sm-12 text-center my-auto">Rack</div>
    <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center my-auto">Device type</div>
    <div class="col-xxl-2 col-xl-2 col-lg-2 col-md-2 col-sm-12 text-center my-auto">Lifecycle</div>
    <div class="col-xxl-2 col-xl-2 col-lg-2 col-md-2 col-sm-12 text-center my-auto">Model name</div>
    <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center">Number of ports</div>
    <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center">Vertical size</div>
  </div>
  <div class="mb-5">
    {% for device in devices %}
      <div class="row border-bottom mx-auto fw-semibold py-2">
        <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center my-auto">{{ device.id }}</div>
        <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 text-center my-auto">
          <button class="btn btn-dark">
            <a class="text-decoration-none text-white"
               href="{{ device.get_absolute_url }}">Edit</a>
          </button>
        </div>
        <div class="col-xxl-3 col-xl-3 col-lg-3 col-md-3 col-sm-12 col-md-3 col-sm-12 text-center my-auto">
          {{ device.rack }}
        </div>
        <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 col-sm-12 text-center my-auto">
          {{ device.get_device_type_display }}
        </div>
        <div class="col-xxl-2 col-xl-2 col-lg-2 col-md-2 col-sm-12 text-center my-auto {% for state, color in device.in_state_colors_tags.items %}{% if state == device.in_state %}{{ color }}{% else %}{% endif %}{% endfor %} text-white py-2">
          {{ device.get_in_state_display }}
        </div>
        <div class="col-xxl-2 col-xl-2 col-lg-2 col-md-2 col-sm-12 text-center my-auto bg-black text-white py-2">
          {{ device.model_name }}
        </div>
        <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 col-sm-12 text-center my-auto">
          {{ device.number_of_ports }} ports
        </div>
        <div class="col-xxl-1 col-xl-1 col-lg-1 col-md-1 col-sm-12 col-sm-12 text-center my-auto">
          {{ device.vertical_size }} U
        </div>
      </div>
    {% endfor %}
  </div>
{% endblock %}

templates/datacenter/footer.html
<footer class="navbar col-10 fixed-bottom text-white bg-dark px-3 mx-auto">
  <div class="mx-auto text-center">zousia@localhost:~/DjangoProjects/2024/datacenter</div>
</footer>

templates/datacenter/home.html
{% extends 'datacenter/base.html' %}
{% block content %}
  {% block racks %}
    {% include 'datacenter/racks-list.html' with racks=racks rack_list=rack_list %}
  {% endblock %}
{% endblock %}

templates/datacenter/navbar.html
{% load static %}
{% load localtags %}
{% get_project_name as project_name %}
{% get_environ_name as environ_name %}
<nav class="navbar navbar navbar-expand-lg col-10 bg-dark border-bottom border-body mx-auto px-3"
     data-bs-theme="dark">
  <div class="container-fluid">
    <a class="navbar-brand text-white text-decoration-none"
       href="{% url 'datacenter:datacenter-home' %}">{{ project_name }} DATACENTER [{{ environ_name }}] {{ in_state_colors_tags }}</a>
    <button class="navbar-toggler"
            type="button"
            data-bs-toggle="collapse"
            data-bs-target="#navbarText"
            aria-controls="navbarText"
            aria-expanded="false"
            aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarText">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <a class="nav-link active"
             aria-current="page"
             href="{% url 'datacenter:datacenter-home' %}">Home</a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{% url 'datacenter:datacenter-home' %}">Racks</a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{% url 'datacenter:rack-create' %}">Create Rack</a>
        </li>
        <li class="nav-item">
          <a class="nav-link"
             href="{% url 'datacenter:datacenter-devices-list' %}">Devices</a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{% url 'drf-racks' %}">API racks</a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="{% url 'drf-devices' %}">API devices</a>
        </li>
      </ul>
    </div>
  </div>
</nav>